// ------------------------------------------
//  Script for managing data with javascript
// ------------------------------------------

var OPT_LIST_IS_HIDDEN   = true;
var INPUT_ON_FOCUS       = false;
var product_list         = [];
var PRODUCT_COUNTER      = 0;
var IS_PRODUCT_CONTAINER = false;
var polygonList;


var makeRequest = function (value) {
    var pol_element = document.getElementById('polygon-list');

    // city request to DB
    // variable req_url in map.html
    $.ajax({
        type : "POST",
        url  : req_url,
        data : {
            'csrfmiddlewaretoken' : document.getElementsByName('csrfmiddlewaretoken')[0].value,
            'value'               : value
        },
        dataType : 'json',
        success  : function(data) {
            polygonList = data.polygonList;

            while (pol_element.firstChild) {
                pol_element.removeChild(pol_element.firstChild);
            }

            if (polygonList.length <= 0) {
                var temp = document.querySelector('#city_list_template');

                // filling template
                temp.content.querySelector('li').id                  = '';
                temp.content.querySelectorAll('span')[0].textContent = 'No cities matched your search. Try again.';
                temp.content.querySelectorAll('span')[1].textContent = '';
                temp.content.querySelectorAll('div')[3].textContent  = '';

                var clone = document.importNode(temp.content, true);
                document.querySelector('#polygon-list').appendChild(clone);

            } else {
                data.polygonList.forEach(function (polygon) {
                    var temp = document.querySelector('#city_list_template');
                    let search_name = polygon.city + ", " + polygon.state;

                    if (!polygon.state) {
                        search_name = polygon.city;
                    }

                    // filling template
                    temp.content.querySelector('li').id                  = polygon.id;
                    temp.content.querySelectorAll('span')[0].textContent = search_name;
                    temp.content.querySelectorAll('span')[1].textContent = polygon.description;
                    temp.content.querySelectorAll('div')[3].textContent  = "Fuente: " + polygon.source;

                    var clone = document.importNode(temp.content, true);
                    document.querySelector('#polygon-list').appendChild(clone);
                });
            }

            if (OPT_LIST_IS_HIDDEN) {
                $('#option-list').show();
                OPT_LIST_IS_HIDDEN = false;
            }
        }
    });
};

var statusUpdateCart = false;
function updateCart(){
    if (statusUpdateCart == false){
        statusUpdateCart = true;
        $("#product-list-cart").empty();
        $.ajax({
            type: 'POST',
            url: prod_from_cartDB_url,
            data: {
                'csrfmiddlewaretoken': document.getElementsByName('csrfmiddlewaretoken')[0].value
            },
            dataType: 'json',
            success: function (data) {
                productsToObtain = [];
                createProductContainer(data.product_list);
                data.product_list.forEach(function (products) {
                    let id = "L-" + products.aggreg_date.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "-");
                    products.catalog.forEach(function (product) {
                        var temp_2 = document.querySelector('#product_cart_2');

                        // filling template
                        temp_2.content.querySelector('li').id = product.uuid;
                        temp_2.content.querySelector('h4').id = product.uuid + "-h4";
                        temp_2.content.querySelector('h4').textContent = product.info.producttype + "_" + product.info.tileid;
                        temp_2.content.querySelector('p').textContent = product.info.beginposition;
                        temp_2.content.querySelector('img').src = product.info.img;
                        temp_2.content.querySelectorAll('span')[1].textContent = product.info.identifier;
                        temp_2.content.querySelectorAll('span')[2].textContent = product.info.size;
                        temp_2.content.querySelectorAll('span')[3].textContent = product.info.instrumentname;

                        var clone_2 = document.importNode(temp_2.content, true);
                        //document.querySelector('#product-list-cart-items').appendChild(clone_2);
                        document.querySelector('#' + id).appendChild(clone_2);
                    });
                });
                hideWaitingModal();
                if (user != "demo"){
                    showCarProductsTabPanel();
                }
                statusUpdateCart = false;
            }
        });
    }
    console.log(user);
    if (user == "demo") {
        window.location.href = "pay";
    }
};

function deleteProductCar(element){
    // let id = element.parentElement.querySelector('span').id;
    // element.parentElement.parentElement.classList.remove('treeview');
    let id = element.parentElement.parentElement.querySelector('span').id;
    element.parentElement.parentElement.parentElement.parentElement.classList.remove('treeview');
    $.ajax({
        type: 'POST',
        url: del_prod_cartDB_url,
        data: {
            'csrfmiddlewaretoken': document.getElementsByName('csrfmiddlewaretoken')[0].value,
            'id' : id
        },
        dataType: 'json',
        success: function (data) {
            //element.parentElement.parentElement.remove();
            element.parentElement.parentElement.parentElement.parentElement.remove();
        }
    });
}

function deleteProductFromShoppingCart(id) {
    $.ajax({
        type: 'POST',
        url: del_prod_cartDB_url,
        data:{
            'csrfmiddlewaretoken': document.getElementsByName('csrfmiddlewaretoken')[0].value,
            'id': id
        },
        dataType: 'json',
        success: function (data) {
            location.reload();
        }
    })
}

function drawPolygon(element) {
    polygonList.forEach(function (polygon) {
        if (polygon.id === element.id) {
            // hide product panel
            $('aside').removeClass("control-sidebar-open");

            // clean product panel
            erase_product_list_globe();

            // remove prev polygon
            osmap.removePolygon();

            var input_text = polygon.city;

            if (polygon.geojson.geometry) {
                var coords = osmap.formatCoords(polygon.geojson.geometry.coordinates);
                // var biggest = osmap.getBiggestPolygon(coords);
                osmap.addPolygon(coords);
                input_text += ", " + polygon.state
            } else {
                osmap.addWKTPolygon(polygon.wkt_polygon);
            }

            // set input box with polygon city name
            $("#ajax-input").val(input_text);
            $('#search_name').val(input_text);
            $("#area_description").val(polygon.description)
        }
    });

    let processTreeview = $('li.processTreeview a');
    let parentClassList = processTreeview[0].parentElement.classList;
    if(!parentClassList.contains('menu-open')){
        processTreeview.click();
    }
}

function erase_input() {
    $('#ajax-input').val('');
}

// $("#id_polygon").on('keyup', function (e) {
//     if (e.keyCode == 13) {
//         polygon = $('#id_polygon').val();

//         osmap.removePolygon();
//         osmap.addWKTPolygon(polygon);
//     }
// });
function showPolygon(){
    polygon = $('#id_polygon').val();
    osmap.removePolygon();
    osmap.addWKTPolygon(polygon);
}

// this function cleans list of available products
function erase_product_list_globe() {
    deletePolygon();
    prevfeature = new Map();
    var pol_element = document.getElementById('product-list-globe');
    while (pol_element.firstChild) {
        pol_element.removeChild(pol_element.firstChild);
    }
}


// this function cleans list of available products by ID
function erase_product_list_globe_by_id(element_id) {
    var $div_element = $('div#' + element_id + "-div");
    var $li_element = $('li#' + element_id + "-li");
    $div_element[0].parentNode.removeChild($div_element[0]);
    $li_element[0].parentNode.removeChild($li_element[0]);
}


// this function cleans list of products in cart
function erase_product_list_cart() {control-sidebar
    var item_element = document.getElementById('product-list-cart');
    while (item_element.firstChild) {
        item_element.removeChild(item_element.firstChild);
    }
}

function deletePolygon(){
    prevfeature.forEach(function(value,uuid){
        if (prevfeature.has(uuid)) {
            osmap.deletefootprint(prevfeature.get(uuid));
            prevfeature.delete(uuid);
        }
    });
};

var prevfeature = new Map();
function drawApiResponse(element) {
    for (var i=0; i<product_list.catalog.length; i++) {
        var data = product_list.catalog[i];
        if (data.uuid === element.id.replace("-li", '')) {
            console.log("footprint:\n", data.product.footprint);
            if (!prevfeature.has(data.uuid)){
                //element.style.textDecoration = 'underline';
                let divh4 = element.children[0].children[1].children[0];
                divh4.innerHTML = divh4.textContent + ' <i class="fa fa-eye" style="color:green"> </i>';
                prevfeature.set(data.uuid, osmap.addfootprint(data.product.footprint, prevfeature));
            }else{
                if (prevfeature.length != 0){
                    //element.style.textDecoration = 'none';
                    let divh4 = element.children[0].children[1].children[0]
                    divh4.innerHTML = divh4.textContent + ' <i class="fa fa-eye-slash" style="color: #dd4b39"> </i>';
                    osmap.deletefootprint(prevfeature.get(data.uuid));
                    prevfeature.delete(data.uuid);
                }
            }

        }
    }
}


function createProductContainer(products) {
    products.forEach(function(list){
        var temp_1 = document.querySelector('#product_cart_1');
        let name = list.aggreg_date.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "-");
        let startDate = new Date(list.startDate).toUTCString().split(' ').slice(0, 4).join(' ');
        let endDate   = new Date(list.endDate).toUTCString().split(' ').slice(0, 4).join(' ');

        temp_1.content.querySelectorAll('span')[0].id          = list.id;
        temp_1.content.querySelectorAll('span')[0].textContent = list.aggreg_date;
        temp_1.content.querySelectorAll('span')[1].textContent = list.process;
        temp_1.content.querySelectorAll('span')[2].textContent = startDate;
        temp_1.content.querySelectorAll('span')[3].textContent = endDate;
        temp_1.content.querySelector('ul .control-sidebar-menu').id = "L-" + name;
        var clone_1 = document.importNode(temp_1.content, true);
        document.querySelector('#product-list-cart').appendChild(clone_1);
    })
}

let productCategory = new Map();
function creatCategoryProductContainer(catalog){
    productCategory = new Map();
    catalog.forEach(function(category){
        if (!productCategory.has(category.product.tileid)){
            productCategory.set(category.product.tileid, 1)
            var temp_1 = document.querySelector('#product_list_category');
            temp_1.content.querySelector('span').textContent = category.product.tileid;
            temp_1.content.querySelector('ul .control-sidebar-menu').id = "L-"+ category.product.tileid;
            var clone_1 = document.importNode(temp_1.content, true);
            document.querySelector('#product-list-globe').appendChild(clone_1);
        }
    })
}

function creatCategoryProductContainer2(catalog){
    productCategory = new Map();

    console.log(catalog);
    console.log(catalog[0].product.title);
    console.log(catalog[0].start_date);
    console.log(catalog[0].end_date);
    console.log(catalog.length);

    var temp_1 = document.querySelector('#product_list_category_2');
    temp_1.content.querySelector('span').textContent = catalog[0].product.beginposition;
    temp_1.content.querySelectorAll('span')[1].textContent = catalog[0].start_date;
    temp_1.content.querySelectorAll('span')[2].textContent = catalog[0].end_date;
    temp_1.content.querySelectorAll('span')[3].textContent = catalog.length;
    temp_1.content.querySelector('ul .control-sidebar-menu').id = "L-"+ catalog[0].product.title;
    var clone_1 = document.importNode(temp_1.content, true);
    document.querySelector('#product-list-globe').appendChild(clone_1);

    productCategory = new Map();
    catalog.forEach(function(category){
        if (!productCategory.has(category.product.tileid)){
            productCategory.set(category.product.tileid, 1)

            var temp_1 = document.querySelector('#product_list_category');
            temp_1.content.querySelector('li').classList.add("hidden");
            temp_1.content.querySelector('span').textContent = category.product.tileid;
            temp_1.content.querySelector('ul .control-sidebar-menu').id = "L-"+ category.product.tileid;
            var clone_1 = document.importNode(temp_1.content, true);
            document.querySelector('#product-list-globe').appendChild(clone_1);
        }
    })
}

function noData(){
    swal("There are no images for your search");
    //No existen imagenes para su búsqueda
}


$('#ajax-input').focus(function () {
    console.log('in');
    INPUT_ON_FOCUS = true;
    if (OPT_LIST_IS_HIDDEN && $(this).val()) {
        $('#option-list').show();
        OPT_LIST_IS_HIDDEN = false;
    }
}).blur(function (event) {
    INPUT_ON_FOCUS = false;
    if (!OPT_LIST_IS_HIDDEN && $(this).val() && $(event.target).closest('#option-list').length) {
        $('#option-list').hide();
        OPT_LIST_IS_HIDDEN = true;
    }
});


$('#polygon-list').click(function () {
    $('#option-list').hide();
    OPT_LIST_IS_HIDDEN = true;
    //$('#area_description').val("hola");
});


$(document).click(function (event) {
    if (!OPT_LIST_IS_HIDDEN && !INPUT_ON_FOCUS) {
        //if click is triggered outside '#option-list' element remove the list
        if(!$(event.target).closest('#option-list').length > 0 ) {
            $('#option-list').hide();
            OPT_LIST_IS_HIDDEN = true;
        }
    }
});


function mssgModal(info) {
    var modal = document.querySelector('#mssg-modal');
    // filling template
    modal.querySelector('.modal-title').textContent                   = info.title;
    modal.querySelector('.modal-body').querySelector('p').textContent = info.body;
    $('#mssg-modal').modal('show');
}


function showProductTabPane() {
    $('#cart').removeClass("active");
    $('#globe').addClass("active");
    $('#control-sidebar-settings-tab').removeClass("active");
    $('#control-sidebar-home-tab').addClass("active");
    $('aside').addClass("control-sidebar-open");
}

function showCarProductsTabPanel(){
    $('#cart').addClass("active");
    $('#globe').removeClass("active");
    $('#control-sidebar-settings-tab').addClass("active");
    $('#control-sidebar-home-tab').removeClass("active");
    $('aside').addClass("control-sidebar-open");
}

function showWaitingModal() {
  $("body").addClass('loading')
  $("#product-list-toggle").addClass('not-active')
  $('aside').removeClass("control-sidebar-open");
}

function hideWaitingModal() {
  $("body").removeClass('loading')
  $("#product-list-toggle").removeClass('not-active')
}

$(document).ready(function () {
    var pol_element = document.getElementById('polygon-list');

    var typingTimer;
    var typingInterval      = 300;  //milliseconds
    var productListGlobe    = [];
    var cartProductList     = [];   // this array represent DB where products will be stored
    var productsToObtain    = [];
    var productUUIDListCart = [];

    // On keyup, start the contdown
    $('#ajax-input').on('input', function () {
        var value = $('#ajax-input').val();
        clearTimeout(typingTimer);

        if (value) {
            typingTimer = setTimeout(makeRequest.bind(null, value), typingInterval);
        } else {
            $('#option-list').hide();

            while (pol_element.firstChild) {
                pol_element.removeChild(pol_element.firstChild);
            }

            OPT_LIST_IS_HIDDEN = true;

            return
        }
    });

    // disable enter in search input
    $('#ajax-input').on('keyup keypress', function(event) {
      var keyCode = event.keyCode || event.which;
      if (keyCode === 13) {
        event.preventDefault();
        return false;
      }
    });

    // var PRODUCT_IN_LIST = false;

    // function for making POST request to productList in view.py
    $('#product-form').submit(function (event) {

        event.preventDefault();
        erase_product_list_globe();
        var submit_data = $('#product-form').serialize();
        showPolygon();
        showWaitingModal()

        // product request to DB
        // variable prod_req_url in map.html
        $.ajax({
            type     : "POST",
            url      : prod_req_url,
            data     : submit_data,
            dataType : 'json',
            error: function (xhr, status, error) {
              console.error("the products request failed");
              hideWaitingModal();
            },
            success  : function (data) {

                productListGlobe = [];
                console.log("DATA: ", data);

                product_list = data;
                // productListGlobe = data.catalog;
                // console.log('GLOBEEE: ', productListGlobe);

                if (product_list.catalog.length > 0) {

                    if (advanced_search == 'True'){creatCategoryProductContainer(data.catalog);}
                    else {creatCategoryProductContainer2(data.catalog);}
                    requestedImages = 0
                    catalogLength = data.catalog.length
                    data.catalog.forEach(function (data, index) {

                        // image request to webservice
                        // variable img_req_url in map.html
                        $.ajax({
                            type : "GET",
                            url  : img_req_url,
                            data : {
                                'value' : data.product.link_icon
                            },
                            dataType : 'json',
                            error: function (xhr, status, error) {
                              // TODO: Agregar una imagen rota por defecto
                              requestedImages++;
                              if (requestedImages == catalogLength) {
                                hideWaitingModal();
                                showProductTabPane();
                              }
                              console.error("image request failed");
                            },
                            success  : function (res) {
                                data.img = res.img;
                                var temp = document.querySelector('#product_list_template');
                                // filling template
                                temp.content.querySelector('.single-product-input').id = data.uuid + "-div";
                                temp.content.querySelector('input').value              = data.uuid;
                                temp.content.querySelector('li').id                    = data.uuid + "-li";
                                temp.content.querySelector('h4').id                    = data.uuid + "-h4";
                                temp.content.querySelector('p').textContent            = data.product.producttype + "_" + data.product.tileid;
                                temp.content.querySelector('h4').innerHTML             = parserDate(data.product.beginposition) + ' <i class="fa fa-eye-slash" style="color: #dd4b39"> </i>';
                                temp.content.querySelector('img').src                  = "data:image/jpeg;base64, " + data.img;
                                temp.content.querySelectorAll('span')[1].textContent   = data.product.identifier;
                                temp.content.querySelectorAll('span')[2].textContent   = data.product.size;
                                temp.content.querySelectorAll('span')[3].textContent   = data.product.instrumentname;

                                var clone = document.importNode(temp.content, true);
                                //document.querySelector('#product-list-globe').appendChild(clone);
                                // console.log('#L-' + data.product.tileid);
                                setTimeout(() => {
                                    document.querySelector('#L-' + data.product.tileid).appendChild(clone);
                                },100);

                                requestedImages++;
                                if (requestedImages == catalogLength) {
                                  hideWaitingModal();
                                  showProductTabPane();
                                }
                            }

                        });

                        productListGlobe.push(data);
                    });

                } else {
                    noData();
                    hideWaitingModal();
                    $('aside').removeClass("control-sidebar-open");
                    //Comenté la siguiente funcion porque causaba error al ser llamada y no aportaba al algun cambio al proyecto
                    // mssgModal({
                    //     title : "No products were found!",
                    //     body  : "Parameters for this search brought no results."
                    // });
                }
            }
        });
    });

    function parserDate(parsedate){
        let fullDate = parsedate.split('T');
        let date = fullDate[0].split('-');
            date = date[1] + "/" + date[2] + "/" + date[0];
        return date + " " + fullDate[1].split('.')[0];
    }

    // adds product to cart
    $('#product-to-cart-form').submit(function (event) {
        event.preventDefault();
        var ul_element = document.getElementById('product-list-globe');

        if (ul_element.firstChild) {
            console.log("ULEMA: ", ul_element);
            var submit_data = $('#product-to-cart-form').serialize();
            console.log("Submitted data:", typeof(submit_data));
            console.log("Submitted data:", submit_data);
            var submit_data_array = submit_data.split("&product_selected=");

            console.log("djdj: ", productListGlobe);
            deletePolygon();
            productListGlobe.forEach(function (data) {
                if (submit_data_array.indexOf(data.uuid) > -1) {
                    console.log("DATA sí esta: ", data.uuid);
                    console.log("SS: ", data.product.size);
                    productsToObtain.push(data.uuid);
                    erase_product_list_globe_by_id(data.uuid);

                    cartProductList.push({
                        'uuid' : data.uuid,
                        'info' : {
                            'producttype'    : data.product.producttype,
                            'tileid'         : data.product.tileid,
                            'beginposition'  : data.product.beginposition,
                            'img'            : data.img,
                            'identifier'     : data.product.identifier,
                            'size'           : data.product.size,
                            'instrumentname' : data.product.instrumentname
                        }
                    });
                }
            });

            $("#product-list-globe").empty();
            if (cartProductList.length > 0) {
                // request for saving product in cart DB
                // variable prod_cart_url in map.html
                $.ajax({
                    type : 'POST',
                    url  : prod_cart_url,
                    data : {
                        'csrfmiddlewaretoken' : document.getElementsByName('csrfmiddlewaretoken')[0].value,
                        'cart_product_list'   : JSON.stringify(cartProductList)
                    },
                    success: function () {
                        cartProductList = [];
                        productUUIDListCart.push.apply(productUUIDListCart, productsToObtain);
                        showWaitingModal()
                        updateCart();
                    }
                });
            } else {
                mssgModal({
                    title : "No products selected!",
                    body  : "Select one or more products to send to your cart."
                });
            }
        }
    });


    // purchasing products in cart
    $('#purchased-product-form').submit(function (event) {
        event.preventDefault();
        var ul_element = document.getElementById('product-list-cart');

        if (ul_element.firstChild) {
            console.log("productUUIDListCart: ", productUUIDListCart);
            var productObject = {};

            productListGlobe.forEach(function (data) {
                if (productUUIDListCart.indexOf(data.uuid) > -1) {
                    productObject[data.uuid] = data.product;
                }
            });

            // L1C product download request
            // variable purch_prod_url in map.html
            $.ajax({
                type : "POST",
                url  : purch_prod_url,
                data : {
                    'csrfmiddlewaretoken' : document.getElementsByName('csrfmiddlewaretoken')[0].value,
                    'product_objects'     : JSON.stringify(productObject),
                    'wkt'                 : $("#product-form input[name=polygon]").val(),
                    'startDate'           : $("#product-form input[name=start]").val(),
                    'endDate'             : $("#product-form input[name=end]").val(),
                    'clouds'              : $("#product-form input[name=cloudPercentage]").val(),
                    'usuario'             : $("#product-form input[name=user_name]").val()
                },
                dataType : 'json'
            });

            erase_product_list_cart();
            IS_PRODUCT_CONTAINER = false;
            productUUIDListCart = [];
        } else {
            mssgModal({
                title : "No products available!",
                body  : "There are no products charged in cart yet."
            });
        }
    });
});
